// Menu, settings, and stats functions

void mainMenu() {

	main40L.update();
	main40L.draw();
  main18B.update();
  main18B.draw();
	mainBomb.update();
	mainBomb.draw();
	mainPractice.update();
	mainPractice.draw();
	mainOptions.update();
	mainOptions.draw();

	if (mousePressed) {
		if (!waitClick) {
			waitClick = true;

			if (mainOptions.over) {			// Options
				mode = 1;
				setKeyBox.setVal(0);
				setKeyBox.setName("");
			} else if (mainPractice.over) {	// Practice mode
				mode = 2;
				startTime = millis();
				initializeGame();
				nextPiece();
			} else if (main40L.over) {		// 40L mode
				mode = 3;
				startTime = millis() + 3000;
				startPlay = false;
				initializeGame();
			} else if (mainBomb.over) {		// bomb stepping mode
				mode = 4;
				startTime = millis();
				initializeGame();
				bombTimer = startTime + 100;
				nextPiece();
      } else if (main18B.over) {  // 18 bombs mode
        mode = 5;
				startTime = millis() + 3000;
				startPlay = false;
				initializeGame();
        for (int i=0; i<18; i++) {
		      bombPos = (bombPos + 1 + int(random(9))) % 10;
		      bombRise(bombPos);
        }
				nextPiece();
        // TODO:  fill this
			}
		}
	} else {
		waitClick = false;
	}
}

void optionMenu() {

	// Texts
	textAlign(LEFT, CENTER);
	textSize(20);
	text(AUTOSHIFTDELAY, 425, 60 + 15);
	text(SONICDROP, 425, 100 + 15);
	text(INSTANTMOVE, 425, 140 + 15);
	text(MOVELEFT, 425, 180 + 15);
	text(MOVERIGHT, 425, 220 + 15);
	text(ROTATELEFT, 425, 260 + 15);
	text(ROTATERIGHT, 425, 300 + 15);
	text(ROTATE180, 425, 340 + 15);
	text(HARDDROP, 425, 380 + 15);
	text(SOFTDROP, 425, 420 + 15);
	text(HOLD, 425, 460 + 15);
	text(CLICKBOXSETSTO, 190, 530 + 15);

	// check keyboard input and put in setKeyBox
	for (int i=1; i<256; i++) {
		if (keys[i]) {
			setKeyBox.setVal(i);
			setKeyBox.setName("" + keyName(i));
			break;
		}
	}

	// Update & draw buttons
	optionDAS.update();
	optionDAS.draw();
	optionSonicDrop.update();
	optionSonicDrop.draw();
	optionZeroARR.update();
	optionZeroARR.draw();
	optionMoveLeft.update();
	optionMoveLeft.draw();
	optionMoveRight.update();
	optionMoveRight.draw();
	optionLeftRotate1.update();
	optionLeftRotate1.draw();
	optionLeftRotate2.update();
	optionLeftRotate2.draw();
	optionRightRotate1.update();
	optionRightRotate1.draw();
	optionRightRotate2.update();
	optionRightRotate2.draw();
	optionFlip.update();
	optionFlip.draw();
	optionHardDrop.update();
	optionHardDrop.draw();
	optionSoftDrop.update();
	optionSoftDrop.draw();
	optionHold1.update();
	optionHold1.draw();
	optionHold2.update();
	optionHold2.draw();
	optionBack.update();
	optionBack.draw();
	setKeyBox.update();
	setKeyBox.draw();

	// Mouse click events
	if (mousePressed) {
		if (!waitClick) {
			waitClick = true;

			if (optionDAS.over) {					// optionDAS
				if (setDAS <= 3)
					setDAS = 12;
				else
					setDAS--;
				optionDAS.setName("" + setDAS);
			} else if (optionSonicDrop.over) {		// sonicDrop
				sonicDrop = !sonicDrop;
				optionSonicDrop.setName("" + sonicDrop);
			} else if (optionZeroARR.over) {		// zeroARR
				zeroARR = !zeroARR;
				optionZeroARR.setName("" + zeroARR);
			} else if (optionMoveLeft.over) {		// move left
				moveLeftKey = setKeyBox.getVal();
				optionMoveLeft.setName("" + keyName(moveLeftKey));
			} else if (optionMoveRight.over) {		// move right
				moveRightKey = setKeyBox.getVal();
				optionMoveRight.setName("" + keyName(moveRightKey));
			} else if (optionLeftRotate1.over) {	// left rotate 1
				leftRotateKey1 = setKeyBox.getVal();
				optionLeftRotate1.setName("" + keyName(leftRotateKey1));
			} else if (optionLeftRotate2.over) {	// left rotate 2
				leftRotateKey2 = setKeyBox.getVal();
				optionLeftRotate2.setName("" + keyName(leftRotateKey2));
			} else if (optionRightRotate1.over) {	// right rotate 1
				rightRotateKey1 = setKeyBox.getVal();
				optionRightRotate1.setName("" + keyName(rightRotateKey1));
			} else if (optionRightRotate2.over) {	// right rotate 2
				rightRotateKey2 = setKeyBox.getVal();
				optionRightRotate2.setName("" + keyName(rightRotateKey2));
			} else if (optionFlip.over) {			// 180 rotate
				flipRotateKey = setKeyBox.getVal();
				optionFlip.setName("" + keyName(flipRotateKey));
			} else if (optionHardDrop.over) {		// hard drop
				hardDropKey = setKeyBox.getVal();
				optionHardDrop.setName("" + keyName(hardDropKey));
			} else if (optionSoftDrop.over) {		// soft drop
				softDropKey = setKeyBox.getVal();
				optionSoftDrop.setName("" + keyName(softDropKey));
			} else if (optionHold1.over) {			// hold 1
				holdKey1 = setKeyBox.getVal();
				optionHold1.setName("" + keyName(holdKey1));
			} else if (optionHold2.over) {			// hold 2
				holdKey2 = setKeyBox.getVal();
				optionHold2.setName("" + keyName(holdKey2));
			} else if (optionBack.over) {			// Back to menu
				mode = 0;
			}
		}

	} else {
		waitClick = false;
	}

}

void initializeButtons() {

	color textColor = color(50);
	color baseColor = color(220);
	color highlightColor = color(255);

	// Main menu buttons
	main40L = new Button(260, 70, 280, 100, TEXT40L, 40, textColor,
							baseColor, highlightColor);
	mainBomb = new Button(410, 190, 280, 100, BOMBER, 40, textColor, 
							baseColor, highlightColor);
	main18B = new Button(110, 190, 280, 100, TEXT18B, 40, textColor, 
							baseColor, highlightColor);
	mainPractice = new Button(260, 310, 280, 100, PRACTICE, 40, textColor, 
							baseColor, highlightColor);
	mainOptions = new Button(260, 430, 280, 100, OPTIONS, 40, textColor, 
							baseColor, highlightColor);

	// Option menu buttons
	optionDAS = new Button(225, 60, 75, 30, "" + setDAS, 20, textColor,
							baseColor, highlightColor);
	optionSonicDrop = new Button(225, 100, 75, 30, "" + sonicDrop, 20,
							textColor, baseColor, highlightColor);
	optionZeroARR = new Button(225, 140, 75, 30, "" + zeroARR, 20,
							textColor, baseColor, highlightColor);
	optionMoveLeft = new Button(225, 180, 75, 30, "" + keyName(moveLeftKey),
							20, textColor, baseColor, highlightColor);
	optionMoveRight = new Button(225, 220, 75, 30, "" + keyName(moveRightKey),
							20, textColor, baseColor, highlightColor);
	optionLeftRotate1 = new Button(225, 260, 75, 30, "" + keyName(leftRotateKey1),
							20, textColor, baseColor, highlightColor);
	optionLeftRotate2 = new Button(320, 260, 75, 30, "" + keyName(leftRotateKey2),
							20, textColor, baseColor, highlightColor);
	optionRightRotate1 = new Button(225, 300, 75, 30, "" + keyName(rightRotateKey1),
							20, textColor, baseColor, highlightColor);
	optionRightRotate2 = new Button(320, 300, 75, 30, "" + keyName(rightRotateKey2),
							20, textColor, baseColor, highlightColor);
	optionFlip = new Button(225, 340, 75, 30, "" + keyName(flipRotateKey),
							20, textColor, baseColor, highlightColor);
	optionHardDrop = new Button(225, 380, 75, 30, "" + keyName(hardDropKey),
							20, textColor, baseColor, highlightColor);
	optionSoftDrop = new Button(225, 420, 75, 30, "" + keyName(softDropKey),
							20, textColor, baseColor, highlightColor);
	optionHold1 = new Button(225, 460, 75, 30, "" + keyName(holdKey1),
							20, textColor, baseColor, highlightColor);
	optionHold2 = new Button(320, 460, 75, 30, "" + keyName(holdKey2),
							20, textColor, baseColor, highlightColor);
	optionBack = new Button(580, 525, 120, 40, "Back", 20, textColor,
							baseColor, highlightColor);
	setKeyBox = new Button(370, 530, 75, 30, "", 20, textColor,
							baseColor, highlightColor);

}

class Button {
	int x, y;
	int width, height;
	int textSize;
	color textColor;
	String name;
	int val;
	color currentColor, baseColor, highlightColor;
	boolean over = false;
	boolean pressed = false;

	// constructor
	Button(int ix, int iy, int iwidth, int iheight, String iname,
			int itextSize, int itextColor,
			int ibaseColor, int ihighlightColor) {
		x = ix;
		y = iy;
		width = iwidth;
		height = iheight;
		name = iname;
		textSize = itextSize;
		textColor = itextColor;
		baseColor = ibaseColor;
		highlightColor = ihighlightColor;
	}

	int getVal() {
		return val;
	}

	void setVal(int ival) {
		val = ival;
	}

	void setName(String iname) {
		name = iname;
	}

	void update() {
		over = over(x, y);
		if (over)
			currentColor = highlightColor;
		else
			currentColor = baseColor;
	}

	boolean over(int x, int y) {
		if (mouseX >= x && mouseX <= x+width &&
				mouseY >= y && mouseY <= y+height)
			return true;
		else
			return false;
	}

	void draw() {
		fill(currentColor);
		rect(x, y, width, height);
		fill(textColor);
		textAlign(CENTER, CENTER);
		textSize(textSize);
		text(name, x + width/2 - 1, y + height/2);
	}

}

String keyName(int keyNum) {
  if (keyNum >= 45 && keyNum <= 93)
    return "" + char(keyNum);
  else if (keyNum == 10)
    return "Enter";
  else if (keyNum == 16)
    return "Shift";
  else if (keyNum == 17)
    return "Ctrl";
  else if (keyNum == 18)
    return "Alt";
  else if (keyNum == 32)
    return "Space";
  else if (keyNum == 37)
    return "Left";
  else if (keyNum == 38)
    return "Up";
  else if (keyNum == 39)
    return "Right";
  else if (keyNum == 40)
    return "Down";
  else if (keyNum == 157)
    return "Cmd";
  else
    return "" + keyNum;
}

